
# Problem Types

The following data structures are all implemented in [GeometricEquations.jl](https://github.com/JuliaGNI/GeometricEquations.jl).
Each problem type is derived from [`GeometricProblem`](@ref).

## Geometric Problems

```@docs
GeometricEquations.GeometricProblem
```

## Ordinary Differential Equations

```@docs
GeometricEquations.ODEProblem
GeometricEquations.PODEProblem
GeometricEquations.HODEProblem
GeometricEquations.IODEProblem
GeometricEquations.LODEProblem
GeometricEquations.SODEProblem
```

## Differential Algebraic Equations

```@docs
GeometricEquations.DAEProblem
GeometricEquations.PDAEProblem
GeometricEquations.HDAEProblem
GeometricEquations.IDAEProblem
GeometricEquations.LDAEProblem
GeometricEquations.SPDAEProblem
```

## Stochastic Differential Equations

```@docs
GeometricEquations.SDEProblem
GeometricEquations.PSDEProblem
GeometricEquations.SPSDEProblem
```
